#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <math.h>

FILE *src, *dest, *bin;

typedef struct {
  char          RIFF[4];
  long unsigned Len1;
  char          WAVEfmt[8];
  long unsigned lUnit;
  unsigned      Unit;
  unsigned      chan;
  long unsigned KHz;
  long unsigned BytePerSec;
  unsigned      BytePerSample;
  unsigned      Bits;
  char          data[4];
  long unsigned Len;
} WAVhdr;

WAVhdr whdr;

unsigned DotLen = 6;
unsigned DotVol = 100;
long unsigned L;
fpos_t Len1pos, Lenpos;

void WriteDash(char &curamp) {
  int i;
  for (i=DotLen*2; i>0; i-- ) {
    fputc( DotVol*curamp + 128, dest ), L++;
  };
  curamp = -curamp;
};

void WriteDots(char &curamp) {
  int i;
  for (i=DotLen; i>0; i-- ) {
    fputc( DotVol*curamp + 128, dest ), L++;
  };
  for (i=DotLen; i>0; i-- ) {
    fputc( -DotVol*curamp + 128, dest ), L++;
  };
};


void WriteByte( char byte, char &curlev, char &curamp ) {
  int i,j;
  for ( i=7; i>=0; i-- ) {
    j = 1&(byte>>i);
    if (j == curlev)
      WriteDots( curamp );
    else
      WriteDash( curamp);
    curlev = j;
  };
}

void main( int _argc, char *_argv[] ) {
   printf("\nĿ");
   printf("\n Bin -> Wav   (Mikrosha format)             ");
   printf("\n");
   if (_argc != 3 ) {
     printf("\n\n Usage:\n tomik <source> <destination> \n\n");
     exit(1);
   };
   if (_argc == 3) {
     if ((src = fopen(_argv[1], "rb")) == NULL) {
       fprintf(stderr, "Cannot open source file.\n");
       exit(1);
     };
     if ((dest = fopen(_argv[2], "wb+")) == NULL) {
       fprintf(stderr, "Cannot open destination file.\n");
       exit(1);
     };
   };


  L = 0L;


  whdr.lUnit = 16L;
  whdr.Unit = 1;
  whdr.chan = 1;
  whdr.KHz = whdr.BytePerSec = 8000L;
  whdr.BytePerSample = 1;
  whdr.Bits = 8;
  whdr.Len1 = 36 + (whdr.Len = L);

  fputc( 'R', dest);
  fputc( 'I', dest);
  fputc( 'F', dest);
  fputc( 'F', dest);
  fgetpos( dest, &Len1pos );
  fwrite( &whdr.lUnit, 4, 1, dest);
  fputc( 'W', dest);
  fputc( 'A', dest);
  fputc( 'V', dest);
  fputc( 'E', dest);
  fputc( 'f', dest);
  fputc( 'm', dest);
  fputc( 't', dest);
  fputc( ' ', dest);
  fwrite( &whdr.lUnit, 4, 1, dest);
  fwrite( &whdr.Unit, 2, 1, dest);
  fwrite( &whdr.chan, 2, 1, dest);
  fwrite( &whdr.KHz, 4, 1, dest);
  fwrite( &whdr.BytePerSec, 4, 1, dest);
  fwrite( &whdr.BytePerSample, 2, 1, dest);
  fwrite( &whdr.Bits, 2, 1, dest);
  fputc( 'd', dest);
  fputc( 'a', dest);
  fputc( 't', dest);
  fputc( 'a', dest);
  fgetpos( dest, &Lenpos );
  fwrite( &whdr.lUnit, 4, 1, dest);

  long unsigned i;
  char curlev= 0;
  char curamp= 1;

  for (i = 0; i <= 50; i++ ) {
    WriteByte( 0, curlev, curamp );
  };

  WriteByte( 0xE6, curlev, curamp );
  while ( !feof(src) ) {
    WriteByte( fgetc( src ), curlev, curamp );
  };

  fsetpos( dest, &Lenpos );
  fwrite( &L, 4, 1, dest);
  L += 36L;
  fsetpos( dest, &Len1pos );
  fwrite( &L, 4, 1, dest);

  fclose(src);
  fclose(dest);

}
